VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTabBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Event Click(ClickedTab As cTab, ByVal MouseButton As Integer, ByVal Shift As Integer, ByVal IsCloseButtonClick As Boolean)

Private Declare Function WindowFromPoint& Lib "user32" (ByVal PX&, ByVal PY&)
Private Declare Function GetCursorPos& Lib "user32" (P As Any)
 
Private WithEvents mPic As PictureBox, mTabs As New Collection, OffsX&
Attribute mPic.VB_VarHelpID = -1
Private WithEvents tmrWatch As VB.Timer, MDownTab As cTab
Attribute tmrWatch.VB_VarHelpID = -1

Public TabWidth&, TextColor&, BackColor&, LineColor&, SelLineColor&, SelColor&, HoverColor&
 
Public Sub BindTo(P As PictureBox, Optional ByVal TabWidth&, Optional ByVal TextColor& = &H333333, Optional BackColor& = &HEEEEEE, _
                                   Optional LineColor& = &HBBBBBB, Optional SelLineColor& = &H666666, _
                                   Optional SelColor& = vbWhite, Optional HoverColor& = &HFFEEDD)
  Set mPic = P
      mPic.ScaleMode = vbPixels
      mPic.AutoRedraw = True
      mPic.FillStyle = 0
      mPic.BackColor = BackColor
  Set tmrWatch = mPic.Parent.Controls.Add("VB.Timer", "tmrWatch" & ObjPtr(Me), mPic)
      tmrWatch.Enabled = False
      tmrWatch.Interval = 60
      
  Me.TabWidth = IIf(TabWidth, TabWidth, 120)
  Me.BackColor = mPic.BackColor
  Me.TextColor = TextColor
  Me.LineColor = LineColor
  Me.SelLineColor = SelLineColor
  Me.SelColor = SelColor
  Me.HoverColor = HoverColor
  Refresh
End Sub

Public Function AddTab(Key As String, Optional Caption As String, Optional oCont As Object, Optional ImageKey As String) As cTab
  Set AddTab = New cTab
      AddTab.Key = Key
      AddTab.Caption = Caption
      AddTab.ImageKey = ImageKey
  Set AddTab.ContObj = oCont: If Not oCont Is Nothing Then oCont.Visible = False
  mTabs.Add AddTab, Key
  Refresh
End Function
 
Public Property Get Count()
  Count = mTabs.Count
End Property
 
Public Sub RemoveTab(oTab As cTab)
  If mTabs.Count < 2 Then Exit Sub
  Dim i As Long
  For i = 1 To mTabs.Count
    If mTabs(i) Is oTab Then mTabs.Remove oTab.Key: Exit For
  Next
  If i > mTabs.Count Then i = mTabs.Count
  If oTab.Selected Then oTab.Selected = False: SelectTab i
  Refresh
End Sub

Public Sub SelectTab(KeyOrOneBasedIndex)
  Dim SelTab As cTab, T As cTab
  Set SelTab = mTabs(KeyOrOneBasedIndex)
  For Each T In mTabs: T.Selected = T Is SelTab: Next
  Refresh
End Sub

Public Property Get Item(KeyOrOneBasedIndex) As cTab
Attribute Item.VB_UserMemId = 0
  Set Item = mTabs(KeyOrOneBasedIndex)
End Property

Public Sub Refresh()
  Dim T As cTab, TSel As cTab, xSel&, xx&, xLastVis&
  mPic.Cls
  xx = OffsX
  For Each T In mTabs
    If xx + TabWidth > mPic.ScaleWidth Then xLastVis = xx: Exit For
    T.Draw Me, mPic, xx
    If T.Selected Then xSel = xx: Set TSel = T
    xx = xx + TabWidth
  Next
  mPic.Line (0, mPic.ScaleHeight - 1)-(xSel + 1, mPic.ScaleHeight - 1), SelLineColor
  mPic.Line (xSel + TabWidth + 1, mPic.ScaleHeight - 1)-(mPic.ScaleWidth + 1, mPic.ScaleHeight - 1), SelLineColor
  If ObjPtr(TSel) Then TSel.Draw Me, mPic, xSel
End Sub

Public Property Get SelectedTabs() As Collection
  Dim T As cTab
  Set SelectedTabs = New Collection
  For Each T In mTabs
    If T.Selected Then SelectedTabs.Add T, T.Key
  Next
End Property

Private Sub Class_Terminate()
  On Error Resume Next
  mPic.Parent.Controls.Remove tmrWatch.Name
End Sub

Private Sub mPic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Set MDownTab = GetTabUnderCursor(X, Y)
End Sub
Private Sub mPic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  GetTabUnderCursor X, Y
  Refresh
End Sub
Private Sub mPic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If Not MDownTab Is Nothing And MDownTab Is GetTabUnderCursor(X, Y) Then RaiseEvent Click(MDownTab, Button, Shift, MDownTab.MouseOverClose)
End Sub

Private Function GetTabUnderCursor(X, Y) As cTab
Dim T As cTab, xx&
  xx = OffsX
  For Each T In mTabs
    T.MouseOver = X > xx And X < xx + TabWidth And Y > 0 And Y < mPic.ScaleHeight
    T.MouseOverClose = X > xx + TabWidth - 18 And X < xx + TabWidth And Y > 0 And Y <= mPic.ScaleHeight / 2 + 2
    If T.MouseOver Then Set GetTabUnderCursor = T: tmrWatch.Enabled = True
    xx = xx + TabWidth
  Next
End Function

Private Sub mPic_Resize()
  Refresh
End Sub
 
Private Sub tmrWatch_Timer()
  If Not MouseOver Then
    Dim T As cTab
    For Each T In mTabs: T.MouseOver = False: T.MouseOverClose = False: Next
    tmrWatch.Enabled = False
    Refresh
  End If
End Sub

Public Property Get MouseOver() As Boolean
Dim PT(0 To 1) As Long
  GetCursorPos PT(0)
  If ObjPtr(mPic) Then MouseOver = (WindowFromPoint(PT(0), PT(1)) = mPic.hWnd)
End Property
